// Demo by Craig S. Kaplan
// Adapted to P5.js by Michael Brooks

// A demonstration of how geometric context affects almost everything
// drawn in a sketch, but not including DOM elements.  So be careful,
// and maybe surround everything with push()/pop().

// TODO - revise phrasing for understanding that P5.js's context does not affect DOM objects
//        even though Processing's context affected ControlP5 objects

let img;
let shp;
let button;

function myBtnPressed() {
  let newLabel = button.html() + ' again';
  button.html(newLabel);
}


function preload() {
    img = loadImage( "data/bowie_150.jpg" );
    shp = loadImage( "data/snowflake10.svg" );  
}


function setup()
{
  let canvas = createCanvas( 500, 500 );

  button = createButton('click me');
  button.size(200, 50);
  button.position(19, 19);
  button.mousePressed(myBtnPressed);
}

function draw()
{
  background( 0 );

  if ( keyIsPressed ) {
    translate( 250, 250 );
    rotate( radians( frameCount * 0.5 ) );
    scale( 0.75 + 0.25 * sin( frameCount * 0.02 ) );
    translate( -250, -250 );
  }

  fill( 255 );
  ellipse( 125, 125, 100, 70 );
  textAlign( CENTER );
  fill( 255 );
  text( "TEST", 375, 125 );
  image( img, 0, 250, 250, 250 );
  image( shp, 250, 250, 250, 250 );
}
