// Craig S. Kaplan
// Rotate an image in the centre of the sketch.

// TODO: vet the "backwards" description of steps here


let img;
let angle;

function preload() {
    img = loadImage( "data/titania150.jpg" );
}

function setup() {
  createCanvas( 400, 400 );
  angle = 0.0;
}

function draw() {
  background( 200 );
  
  // Note that I describe the transformations
  // below in reverse order.  Yes, they're really
  // applied that way.  The key is to realize that
  // each transformation "sets up a context" in
  // which future transformations operate.  So
  // when you draw something, you walk back outward
  // to the top level, applying the accumulated
  // transformations as you go.
  
  // Finally, move the whole thing down to
  // the centre of the sketch.
  translate( width/2, height/2 );
  // Next, it's safe rotate the image by the
  // current angle.
  rotate( angle );  
  // First, slide the image back so that its
  // centre lies on the point (0,0)
  translate( -img.width/2, -img.height/2 );
  
  image( img, 0, 0 );
  angle += 0.01;
}