// Craig S. Kaplan
// An example of rotating about arbitrary points.
// Click on a point in the sketch window to set it
// as the anchor point for rotation.  Use a 
// rotateAboutPoint() helper function to streamline
// the transformation process.

let cx = 250;
let cy = 250;

function rotateAboutPoint( x, y, theta ) {
  translate( x, y );
  rotate( radians( theta ) );
  translate( -x, -y );
}

function setup() {
  createCanvas( 500, 500 );
}

function drawShape() {
    rect( 100, 200, 300, 100 );
    fill(0);
    text("e", 250, 250);  
}

function draw() {
  background( 80 );
  ellipseMode(CENTER);
  textAlign(CENTER, CENTER);
  textSize(30);  
  stroke(0);

  noFill();
  drawShape();
  
  push();
    rotateAboutPoint( cx, cy, frameCount );
    fill(255);
    drawShape();
  pop();
  
  fill(0, 0, 255);
  ellipse(cx, cy, 10, 10);
}

function mousePressed() {
  cx = mouseX;
  cy = mouseY;
}
